﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UltraTreeDataBinding.Logic
{
    public class RandomCharLogic
    {
        Dictionary<char, char> m_Chars;



        private static char ByteToChar(byte p_Byte)
        {
            byte FirstLetterByte = System.Text.Encoding.UTF8.GetBytes("A").First();
            char CurrentChar = System.Text.Encoding.UTF8.GetString(new byte[] { (byte)(FirstLetterByte + p_Byte) }).First();
            return CurrentChar;

        }

        public RandomCharLogic()
        {
            m_Chars = new Dictionary<char, char>();

            Random Output;
            Output = new Random();

            byte FirstLetterByte = System.Text.Encoding.UTF8.GetBytes("A").First();

            for (byte i=0; i< 26; i++)
            {

                
                char CurrentChar = System.Text.Encoding.UTF8.GetString(new byte[] { (byte)(FirstLetterByte + i) }).First();
                

                byte Offset = 0;
                while(m_Chars.ContainsValue(ByteToChar(Offset)))
                {
                    Offset = (byte)Output.Next(minValue:0, maxValue: 26);
                }

                m_Chars.Add(CurrentChar, ByteToChar(Offset));
                
                                    

            }




        }


        /// <summary>
        /// Return the characters.
        /// </summary>
        public string ChangeChars(string p_Input)
        {
            string Result = string.Empty;
            if(p_Input.Length <= 5) 
            { 
                Result = p_Input;
                return Result;
            }

            if (p_Input == "Posted Activity")
            {
                Result = p_Input;
                return Result;
            }

            int Position = 0;
            if(p_Input.StartsWith(@"P&L "))
            {
                Result = @"P&L ";
                Position = 4;
            }

            while(Position < p_Input.Length)
            {
                char CurrentPosition = p_Input.Substring(Position, 1).First();
                Result = Result + (m_Chars.ContainsKey(CurrentPosition) ? m_Chars[CurrentPosition] : CurrentPosition);
                Position++;
            }

            return Result;

        }
    }
}
